<?php
function nxt_replace_url() {
	check_ajax_referer( 'nexter_admin_nonce', 'nexter_nonce' );
	
	$from = ( isset($_POST['from']) && ! empty( $_POST['from'] ) ) ? sanitize_url($_POST['from']) : '';
	$to = ( isset($_POST['to']) && ! empty( $_POST['to'] ) ) ? sanitize_url($_POST['to']) : '';
	
	$case = ( isset($_POST['case']) && ! empty( $_POST['case'] ) ) ? sanitize_text_field( wp_unslash($_POST['case']) ) : '';

	$from = trim( $from ); $to = trim( $to );

	if ( $from === $to ) {
		wp_send_json_error(
			array(
				'success' => false,
				'message' => __( 'The "OLD" and "NEW" URLs must be different', 'nexter' ),
			)
		);
	}
	
	/* Check Valid URL or Not*/
	
	//$is_valid_urls = ( filter_var( $from, FILTER_VALIDATE_URL ) && filter_var( $to, FILTER_VALIDATE_URL ) );
	// if ( ! $is_valid_urls ) {
	// 	wp_send_json_error(
	// 		array(
	// 			'success' => false,
	// 			'message' => __( 'The "OLD" and "NEW" URLs must be valid URLs', 'nexter' ),
	// 		)
	// 	);
	// }

	global $wpdb;	
	$rows_affected = $post_Ser = $meta_Ser = 0;
	
	if($case=='yes'){
		$post_Ser = $wpdb->query($wpdb->prepare("SELECT ID, post_content FROM wp_posts WHERE (post_content LIKE BINARY '%".$from."%')"));
		$meta_Ser = $wpdb->query($wpdb->prepare("SELECT meta_value FROM wp_postmeta WHERE (meta_key='_tpgb_css' AND meta_value LIKE BINARY '%".$from."%')"));
	}else if($case=='no'){
		$post_Ser = $wpdb->query($wpdb->prepare("SELECT ID, post_content FROM wp_posts WHERE (post_content LIKE '%".$from."%')"));
		$meta_Ser = $wpdb->query($wpdb->prepare("SELECT meta_value FROM wp_postmeta WHERE (meta_key='_tpgb_css' AND meta_value LIKE '%".$from."%')"));
	}
	$rows_affected = $post_Ser + $meta_Ser;
	
	wp_send_json_success(
		array(
			'result' => $rows_affected,
		)
	);
}


function nxt_replace_confirm_url() {
	check_ajax_referer( 'nexter_admin_nonce', 'nexter_nonce' );
	
	$from = ! empty( $_POST['from'] ) ? sanitize_url($_POST['from']) : '';
	$to = ! empty( $_POST['to'] ) ? sanitize_url($_POST['to']) : '';
	
	$case = ( isset($_POST['case']) && ! empty( $_POST['case'] ) ) ? sanitize_text_field( wp_unslash($_POST['case']) ) : '';
	
	$from = trim( $from ); $to = trim( $to );
	
	global $wpdb;	
	$rows_affected = $post_cnt = $meta_val = 0;
	
	if($case=='yes'){
		$post_cnt = $wpdb->query($wpdb->prepare("UPDATE wp_posts SET post_content = REPLACE(post_content, '".$from."', '".$to."') WHERE (post_content LIKE BINARY '%".$from."%')"));
		$meta_val = $wpdb->query($wpdb->prepare("UPDATE wp_postmeta SET meta_value = REPLACE(meta_value, '".$from."', '".$to."') WHERE (meta_key='_tpgb_css' AND meta_value LIKE BINARY '%".$from."%')"));
	}else if($case=='no'){
		$post_cnt = $wpdb->query($wpdb->prepare("UPDATE wp_posts SET post_content = REPLACE(post_content, '".$from."', '".$to."') WHERE (post_content LIKE '%".$from."%')"));
		$meta_val = $wpdb->query($wpdb->prepare("UPDATE wp_postmeta SET meta_value = REPLACE(meta_value, '".$from."', '".$to."') WHERE (meta_key='_tpgb_css' AND meta_value LIKE '%".$from."%')"));
	}
	$rows_affected = $post_cnt + $meta_val;
	
	wp_send_json_success(
		array(
			'result' => $rows_affected,
		)
	);
	
}

add_action( 'wp_ajax_nxt_replace_url', 'nxt_replace_url' );
add_action('wp_ajax_nopriv_nxt_replace_url', 'nxt_replace_url' );

add_action( 'wp_ajax_nxt_replace_confirm_url', 'nxt_replace_confirm_url' );
add_action('wp_ajax_nopriv_nxt_replace_confirm_url', 'nxt_replace_confirm_url' );












?>